New in Version 4.5.0 (436):
- "Whole Track -> Remap objects to blocks" now searches for the nearest track polygon & and uses FindZOnRoad (from Drop function).
- Texture overview integrated. Click on the currently used one to get an overview.
- LoadQFS now recognises mirrored images of type 0x7D. This fixes the track preview of "Durham Road".
- LoadQFS now recognises mirrored images of type 0x78. This fixes the track preview of NFS2 conversions like "Mediterraneo".
- LoadQFS now does color corretions on bitmaps from typ 0x7E. It gives better Looking NFS3 textures.


New in Version 4.4.0 (434):
- Bugfix-Copy_VRoad.
- Bugfix ShowSelection for polygon objects.
- Bugfix for pasting objects to the same block. (Messed up the VRoad there.)
- Updated help file by AJ Lethal.

New in Version 4.4.0 (433):
- Recalculate speed or position between two AI Points:
  + Enable "Edit Mode - Virtual Road Points". 
  + Select Speed File for Viewing (Forward / Backward). 
  + Select first AI Point with ALT pressed. 
  + Select second AI Point with CRTL & ALT pressed. 
  + Recalculate speed between two AI Points with SHIFT-S. If you want to recalculate the position (float values) between two selected AI points use SHIFT-Q.
- Animated objects data accepts neative numbers.
- Import Off-objects: y-z swapped.
- VRoad lanes recalc changed.
- TrackView starts with a bigger window.
- Show Block Direction added.
- Show / Hide track (black) Polygons added.
- "Edit-Modes" - "Select only from current block" added. You can quickly toggle the one block view with the "Scroll-Lock" key.
- Moving the speeedfile data is now flexible. You can set it by "File" - "Set Speedfile Shift Amount".
- Fix - Selecting a line of points bug, when the last point is from extra object.


New in Version 4.4.0 (432):
- Deleting all selected Polygons is now possible (not only the last).
- Deleting all selected Objects works, too.
- Interpolation of float values between two AI Points (using cosine) Select first (holding ALT) then second (CTRL + ALT) and start calculation with SHIFT + Q. By Default curve calculation is done, use ALT + SHIFT + Q for straight Interpolation.
- With “Clear / Modify All...” all float values of the speed files can be set to zero.
- With “Clear / Modify All...”, float values that are zero can be recalculated (as straight or curve). An interpolation is made between the first and the last value that is not zero.
- Improved undo function:
	* Increased possible undos from 16 to 64.
	* Undo possible if deleting and adding blocks.
	* Undo points won't be deleted when saving track.

New in Version 4.4.0 (431):
- Duplicating multiple lanes and fences works now as wanted.
- New function "Edit-Tools_-_Add Lane".
- Fix for moving extra object polygons.

New in Version 4.4.0 (430):
- Bugfix duplicating multiple track polygons.

New in Version 4.4.0 (429):
- Bugfix on pasting objects.
- Holding ALT-key when pasting objects keeps the original position.
- Fixed a bug when changing spdfile float and Recalc AI lane selection was aktive.
- Big changes to selecting function (LButtonDown): It is now possible to select a row of polygons or points. Select the first, then hold "Shift" an select the last. All on a line between them wil be selected.

New in Version 4.4.0 (428):
- Fix for dropping "Virtual Road Points", the lowest hit will now be used.
- Fix for not showing position when selecting "Virtual Road Points".
- "Import - Virtual Road, heights, spdfa spdra". Fix for messageboxes that don't show up.
- "New/Duplicate" (Ctrl + N) usually splits trackpolygons to create a new. If it's the first or last of a row, it now adds one to the side. If you want the split function hold the "Alt" key.

New in Version 4.4.0 (427):
- Updated "Virtual Road, heights, spdfa, spdra" with "HS_Extra" data.
- Updated Export / Import "Virtual Road, heights, spdfa spdra" with "HS_Extra" data.
- Improved "Adjust virtual road" with "Automatic lane detecttion".
- Virtual Road & AI Points are not normal objects anymore. You have enable "Virtual Road Points" Edit-Mode to change them.
- In "NFSHS Texture Properties" you can enable the "Scroll effect". Scroll direction is set by "Rotation".

New in Version 4.4.0 (426):
- Edit of sound / light object position in properties.
- "Unknown Data" now shows the selected byte as bits.
- "Virtual Road, heights, spdfa & spdra" now shows the real VRoad numbers. Not just 1,2,3..
- The Replay Camera Editor has now a "Edit Unknown Rotate Values" button.

New in Version 4.4.0 (425):
- No delete for VRoad Points, T3ED would crash.
- "Texture" function disabled for special objects, T3ED would crash.
- "Virtual Road, heights, spdfa & spdra" now shows the VRoad information about shortcuts. Each VRoad point contains two possible numbers. If there is none both are -1.
- Fix for "Point properties" when only changing the coordinate. (Thanks PomFrit)

New in Version 4.4.0 (424):
- "Polygon Virtual Road Flags" You can now choose whether "Drive over behavior" should be set or remain as original.
- "Shadow ray tracer" the maximum end block has been corrected from 255 to 299.
- "Find polygon" Now you can specify how many percent of the hits should be selected. 

New in Version 4.4.0 (423):
- Multiple polygons can now be duplicated instead of only one.
- If showing "Virtual Road Boundary Polygons" 
  * Polygons with "No ?? Neighbour" flag get line from middle pointing to the corresponding direction.
  * Polygons with "Extra Object Detection" flag get an "E".
  
New in Version 4.4.0 (422):
- New (better?) track format detection. (Using the four first bytes.)
- Bugfix when pasting whole blocks.The "HS_EXTRA" VRoad data was placed in a wrong position.
- "Connect Close Points" function from block neighbours is now also in "Clear / Modify All".

New in Version 4.4.0 (418):
- "Clear / Modify All" has now a option to recalc PolyVroad for the whole track.
- Ctrl + R is Polygon rotation (90°) by changing the points. Now, in HS Mode with "Crtl + Alt + R", it rotates the textures too.

New in Version 4.4.0 (417):
- Three modes for PolyVRoad calculation (Crtl + H)

New in Version 4.4.0 (416):
- Resize Track(now negative values possible)
- Enter Move Distance: The data from the last mouse move can be used. Another alternative is to use the data from the last distance measurement. Distances can be calculated in point mode by picking two points.
- Bugfix when using ALT & MouseWheel with no 3D View .

New in Version 4.4.0 (415):
- Option to show PolyVRoad for (black) trackpolygons. It should always point forward. But now I can be changed with "Polygon Virtual Road Flags". 
- Bugfix when replacing blocks und using undo.

New in Version 4.4.0 (414):
- Light Raytracing for lanes added.

New in Version 4.4.0 (413):
- Zoom In/Out now works when Track View windows is active.
- Zoom In/Out Track View only (using ALT Key) is now much faster.
- Additional safety check when starting Track View.
- Light properties has now a Combobox for easy selection of track glows (values taken from Tr(N).ini) or special effects.
- Light properties has a Raytrace Light button. Maximum Light Distance will be intensity * 0.1.
- Light/Sound properties will be shown as four bytes. Byte 2 has to be zero, to be visible in game. If not, only raytracer will use it.
- Delete Light/Sound object from block properties.

- Shadow Raytracer can now calculate lights:
  * A imaginary line from each light to vertice points will be calculated. Only when nothing is in the way the light shines there.
  * Light color and intensity will be taken from tr(N).ini
  * Multiplier of light distance can be set. Light Distance will be intensity * multiplier.
  * If red, green or blue of light is higher than the color part of the point it will be replaced.
  * Flashing Lights will be ingnored.
  * Byte 2,3,4 of Light will be ignored.


New in Version 4.3.0 (411):
- Added another check when enabling Trackview, to avoid crashes.
- Zoom it/out Trackview only(using ALT key) is much faster now.
- Mousewheel for zooming now works with active Trackview window.

New in Version 4.3.0 (410):
- Modified Polygon Virtual Road Flags:  
   Fixes a bug for "Drive over behavior",
   Added "Disable weather effects (NFS4 Only)". Bit 5 isn't used in NFS3.
- Added Ex & Import "Virtual Road, heights, spdfa spdra" for NFS3. I had only made the NFS4 version.

New in Version 4.3.0 (409):
- Type 6 extra objects:
  Mass of the object can be changed. (Unknown data byte 0-3)
  Hitbox of object will be recalculated, when converting from extra to global object. (Unknown data byte 40-51)
  Thanks to AJ_Lethal for discovering this.

New in Version 4.3.0 (408):
- Fixed "Virtual Road, heights, Speedfiles" view for NFS3.
- New function that shows unknown data. Currently used for HS_Extra (VRoad) and Type6 object data.

New in Version 4.3.0 (406):
- Ex & Import "Virtual Road, heights, spdfa spdra" Bugfix.

New in Version 4.3.0 (405):
- Ex & Import "Virtual Road, heights, spdfa spdra" now includes VR Left / VR Right, L-Lane Polys / R-Lane Polys, Width L-Polys / Width R-Polys.

New in Version 4.3.0 (404):
- Added AI points which are at the VRoad point + the float numbers of the speed files. 
  Enable "Show Virtual Road Width and Node Points" to see AI Points.
  With "Show Virtual Road Bitmap Data Mode" you see a thin red line AI line.
  Use "View -> Select Speedfile for viewving" to choose the AI Line you want to see. (Forward / Backward)
  If you zoom in, AI Points get a up to down line indicating the speed.
  In object mode, AI points can be selected by holding down the ALT key. (CTRL & ALT if you want to select more then one.)
  If you move AI Points (X & Y), T3ED recalculates the "AI lane" from speedfile. 
  If you move the AI Point Up / Down the Speed of spdFA or spdRA will be changed.
  
Thanks to "PomFrit" who found out how everything is connected and how it works.

- "Virtual Road, Heights" now has additional columns.
  "VR Left" / "VR Right" - The purple VRoad Borders
  "L-Lane Polys" / "R-Lane Polys" - The number of light green polygons. (Could already be changed with adjust road width)
  "Width L-Polys" / "Width R-Polys" - The width of the lane polygons.

New in Version 4.3.0 (400):
- Fix moving multiple vroad points (wasn't working anymore).
- Drop vroad refpoints (Alt D).
- Drop lanes down on road (black & blue polys, Alt D).
- Drop points, polygon & extra objects on track and object polygons (Alt D).
- Add lights (ctrl + l) on selected points, polygons (middle) or objects (middle). 
- Add sounds on selected points, polygons (middle) or objects (middle). 
- Added 'Colorbuttons' to make it easier to select shading colors.

New in Version 4.3.0 (393):
- Paste X & Y (Shift Y) and Paste Z (Shift Z) now uses the clipboard. Copy point to clipboard before (Ctrl C).
- Bug fix for entering move distance, directly after deleting a polygon.
- Auto adjust Z on virtual road points when moving (X & Y). Won't be done if Altkey pressed, or z is moved.
- Auto adjust Z when moving lane points (X & Y). They will be placed 0.025 above the track polygon below. If you don't want it press Alt while moving.

New in Version 4.3.0 (390):
- Replay Cameras will be sorted.
- When saving: Show warning messages if track breaks limits. Which are 512 for crosstype 4 extra objects and 128 for crosstype 6 global objects. Thanks to Zalcus20 for the info.
- Bugfix when selecting blue polygons.
- Safety checks for the "Move" function.
- Improved "Paste Block" function.

New in Version 4.3.0 (386):
- If you paste a block, object or camera the mode on destination will be changed automaticly.
- Current t3ed settings will be stored to <frd-name>.settings.t3ed, and loaded automaticly when re-opening the track.
- Paste block to current vroad added.
- If you import a Vr_H_Spd.csv file with changed virtual road values, the track can be rearranged to that new virtual road. This can be used to change track shapes.
- Bug fix for Pasting HS extra data (Number of lanes)
- New option: Set visibility minimum.
- New function: Copy & paste virtual road points. You can select what will be pasted. Position & vectors, Heights data, spdFa data, spdRa data or HS extra Data (Number of lanes)
- When converting (Global, extra & polygon) objects you won't lose shadow/color information anymore.
- The "Show track based on visibility" mode has been improved if a global object is selected.
- Several safety checks have been added to avoid illegal memory calls. I think this version has the best stability of the ones I made. If you find a error that can be reproduced please let me know.
- Integrated Replay Camera Editor:
	Replay Camera are now objects.
	Move, copy, and delete them like other objects.
	"Tr.cam" will be loaded / saved with the frd-file.
	Enable viewing cameras by "View -> Show Replay Cameras"
	When a camera is selected a light blue line from camera start to stop will be display along the virtual road. You can adjust the cameras start and stop with (Alt) PG Up/Down keys.
	When you press "Alt" while moving a camera, T3ED will adjust start, stop and render.

New in Version 4.2.0 (343):
- Improved "Erase all" function. Instead of turning the track into a circle you have much more options now: Set a x and y multiplier, and add additional curves with the sine function. It can also be used to make ups and downs.
- Copy & Paste blocks with hs_extra data. (Number of lanes.)
- Paste block as object: The object will now be exactly at the blocks position. You have to move it when necessary.
- Simplified Code for selecting Virtual Road-Points.
- Block Highlighting will now work for Virtual Road Points.
- Virtual Road Points will be shown as stars instead of crosses.
- Import & export of Virtual Road, Heights, spdfa and spdra data to "Vr_H_Spd.csv". 
- Fix for pasting blocks with other than 8 slices.
- Fix for pasting only spdfa / spdra data. In older versions a recalculation of “poly vroad” on block 0 was done with wrong parameters.

New in Version 4.2.0 (326):
- "Adjust road width" : Deleted the experimental VRoad lane manipulation.  It seems that the width is related to the number of lane (light green) polygons. You now can set the number left and right from road middle.

New in Version 4.2.0 (323):
- Remap objects to block. Calculates the distance between the object middle and block middle. And them moves the data to the block with shortest range.
- Resize whole track. I made experiments with “Transtropolis”. XY values above  1.15 messes up the visibility.
- The extra object properties dialog has been changed to fit on 1024x768 screens.
- Fixed a bug that occurs when converting objects.
- "Adjust road width" with experimental VRoad lane manipulation.

Raytracing:
- Added an option to select lane (chunk 6) and fences (chunk 1,2,3)
- Raytracing  moved it to ‘Whole track’ menu.
- Option "Copy shadow to very close points" added to avoid hard separations between shaded and unshaded surfaces.

New in Version 4.2.0 (309):
Visibility:
- When exporting visibility, the file will be saved in the track directory.
- With “Show track based on visibility” you can now use the right mouse button to set visibility edges of the selected block. Control + right mouse toggles the block.
- Better handling of visibility when you delete / insert a block.

NFS3/4
- Bugfix for deleting the last block of a track with less then 8 virtual road points.
- Ability the change all texture of a block with its objects in one step.
- Show more info about what is selected in the status bar.
- When moving virtual road points manually, the „ColVroadVecs“  of track polygons will be recalculated.
- You can change all texture of a block or an object in one step. (Edit → Texture when in block or object mode.)
- “File → Changes all textures” to edit all texture numbers of the track,
- Export a block to an off – file.
- Paste a block as polygon (blue) object.
- Rewritten for “Adjust road width” function.
- Added an “Adjust road width” button to block properties.

For NFS3
- T3ED loads now the nfs3 heights file "simhts.dat" and the speed files "speedsf.bin/speedsr.bin".
- Adjust the “col.vroadHead.size” to allow paste/delete blocks on nfs3 tracks!
- Changes to the texture dialog on nfs3 tracks:
   It shows the texture id and the bitmap number in the qfs – file.
   NFS3 Texture Properties dialog was added. It allows to change two sided & animated textures.
- Import/Export the NFS3 textureblock.

HS Only:
- Gobal object chunk 1 will be loaded and saved correctly. (Cross-) type 6 object are now visible.
Type 6 objects can be deleted, duplicated and moved as global objects. To edit them, convert to an extra object, make the changes, and convert back to global.
- Since I don’t understand all type6 data, the unknown 60 bytes can be exported & imported. I think it stores the weight, behavior and size.

Shadows:
- Clear / Set shadows of extra objects manually. You can also change the color and transparency of the objects texture there!
- Point Properties with shading values.
- Many changes to Nappe’s ray tracer:
* Extra object can get shadows.
* Set sun and shadow color.
* You can now select what object get new shadows
* Select object that cast shadows
* If you set transparency, this points can be ignored from ray tracer

New in Version 4.0 :

- A new paste mode has been added. “Replace only track texture information”. It will replace all texures and poperties from trackpolygones. Objects won’t be changed.
- A new view has been added “Show Track Based On Visibility”. Unvisible blocks are show in a light grey, and can’t be selected.
- Fix for crashing when selecting global objects and active trackpreview.
- Default trackpreview shows now two more blocks.
- If “Show Track Based On Visibility” is activated, trackpreview shows blocks that should be visible in game, up to 30 blocks. Global objects will always be shown in trackpreview.
- Visibility information can be changed for actual block by using [Alt] Page Up/Down keys. “Show Track Based On Visibility” must be enabled.
- Size of trackpreview window can be easier changed now.
- Use CTRL + MouseWheel to zoom in/out trackpreview without changing normal view scale.
- Fix for program crashing when converting global objects.


New in Version 3.9 :

- Global NFS4 object manipulation added. Global object will now be shown, can be moved and converted in extra objects and back.
- It is now possible to delete any block from the track. Not only at the end.
- Paste block from Clipboard before selected block added. (Be carefull, not very well tested !)
- Added a file "TrackPreviewfix_(dgVooDoo).zip" including DDraw.dll & D3DImm.dll from dgVoodoo to fix TrackPreview problems.
- Fixed  t3ed from crashing when seleting global objects with TrackPreview on.

New in Version 3.8 :

- Frd file properties dialog added.
- Block properties dialog added.
- New function “Edit -> Find” for polygons added. You can search for polygons by texture, HS texture properties, texture animation data and polygon road flags (drive-over behavior).
- VRoad refpoints will be handled as extra objects. Select “Edit Virtual Road Points” and you can move them like you want.

For NFS4 only :

- If available height.sim, spdfa.bin and spdra.bin will be loaded and saved with the tr.frd file. (Thanks to Christian Brandt & Lasse Karkkainen for their NFS4 Spdtools.)
- Heights.sim, spdfa.bin & spdra.bin data will be copied and pasted together with block data.
- Undo for Heights.sim, spdfa.bin & spdra.bin data added.
- New dialog “Edit Tools - > Virtual Road, heights, spdfa & spdra” (Ctrl+H) allows to edit that values. In block mode all data from actual block is shown. In object mode all data from selected VRoad refpoints will be displayed if properties is selected from menu. Note : The “spdXA Speed” has only 4 values per block all others have usually 8. That’s why speed values are shown twice, e.g. 0=1,2=3,4=5 and 6=7. Only the first (0,2,4,6) will be written to disk.

New in Version 3.7:

- Textures of new created objects won’t be animated be default anymore. This caused serveral HS crashes.
- Import (extra) objects from ‘.off’ files. Object File Format contains no texture information, only strucutres can be imported. Because NFS only supports polygons with 4 vertices other will be transformed into 4 poly ones. Polygons with more than 8 vertices can’t be imported.
- Export (extra) objects to ‘.off’ files.
- The texture function for objects can now set NFS HS Texture properties.
- New “merge objects” function. Go to object mode,  enable the merge/split button. When you select two (extra) objects the second will be merged into the first.
- Polygon & extra objects can be moved into another chunk. Turn off “Automatic Object Membership” and open properties. (ALT + Enter).
- Roate for polygons (NFS3 compatible, rotates the texture without using HS Texture Properties.)
- Invert polygons function (CTRL + I), turns over front & back.
- Much more extra object properties are shown and can be changed. For example, the crosstype can be changed. That allows to make objects hitable. The colide effect specifies how they behave. Solid like trees/walls (1) or like signs (2).
- In the extra object properties dialog, the animation data can be exported & imported to a text file. And finally the length of the animation can be changed. Bigger ones that the simple rotating donut on snowy are possible.
- New object can be created as animated objects.
- Show objects middle in status bar.

Some explaining videos are on youtube :

T3ED Dev 3.7 : Import Off Objects

T3ED Dev 3.7 : Object conversion and creation of animations.

New in Version 3.6 :

- “Undo, but keep VRoad” added. The VRoad can be moved in block mode, when the track is moved. Now there a undo which brings back the track, but keeps the moved VRoad.
- Adjust road width fixed. Now you really can select the blocks which should be adjusted.
- Copy whole block to Clipboard
- Paste block as new additional block.
- Replace the currently selected block, with block from clipboard. Move and, or rotate the new block in old position.
- Moving blocks without smoothing by pressing control.
- Rotate whole blocks.
- The “Expand / Shrink”, “Rotate”, “Shadow Raytracer”, “Add / Replace Block” & “Adjust Road Width” windows are keeping their settings for the next call.
- Polygon / extra object properties added (ALT+ENTER). If  “Automatic Object Membership” is off, you can manually change the block where the object belongs to.
- Move distance can be manually entered.
- Show the refpoint position in status bar when block mode is active.
- The Block Neighbours function has now an option to connect points to near points of neighbour blocks.
- Line up x,y, (z) function for point mode added.

New in Version 3.5 :

- Copy Polygon-, Extra-, Light- & Sound- objects to clipboard. You have to be in object mode and use Ctrl + C or “Edit -> Copy” from menu.
- Paste Polygon-, Extra-, Light- & Sound- objects from clipboard to another block or even track ! Select object mode and use Ctrl + v or “Edit -> Paste” from menu.

New in Version 3.4 :

- Rotate (extra-) objects around their middle.
- New / Duplicate function has a new shortcut Ctrl + D or Ctrl + N. (Ctrl + V will be used for clipboard.).
- Copy position of a point to Windows clipboard (Ctrl + C).
- Paste clipboard postion to a point (Ctrl + V)

New in Version 3.3:

- Change textures of trackpolygons, polygon & extra objects in one step. Choose the new lowest texture and all textures will be change with the same offset.
- Expand / Shrink (extra) objects is now possible. You can select each axis independent or connected. It’s selectable on which position the object will be aligned. (Top, middle or bottom.)
- Fixed light & sound source properties. Values can be changed directly in T3ED now, for thoose who don’t want to use the frd-tool.
- In point mode : Ctrl + Y copy X & Y position to memory, Shift + Y paste memory position to selected point(s).

New in Version 3.2:

- Track shading tracer, by - Lasse Kärkkäinen aka. Nappe1. It’s one of the last thing he implemented before he gave up working on T3ED. All credits should go to him.
- Mousewheel can be used to zoom in / out.
- Compiled DirectX sdk sum2004 which is the latest working with VS6.
- Added options for LOD Generator and Track shading tracer. (Start Block, End Block, etc.)
- After moving objects, the they will be stored in the Block which is closest to the new position.